import{s as mt,o as ut,n as pt}from"../chunks/scheduler.69131cc3.js";import{S as gt,i as ft,g as n,s as r,r as p,A as bt,h as c,f as t,c as s,j as L,u as m,x as i,k as D,y as o,a as l,v as u,d as g,t as f,w as b}from"../chunks/index.e1f30d73.js";import{T as ht}from"../chunks/Tip.22e79575.js";import{D as I}from"../chunks/Docstring.ae1a1e2d.js";import{H as He}from"../chunks/Heading.0aab6758.js";function _t(K){let d,z=`<code>BatchSampler</code>s with varying batch sizes are not enabled by default. To enable this behaviour, set <code>even_batches</code>
equal to <code>False</code>`;return{c(){d=n("p"),d.innerHTML=z},l(h){d=c(h,"P",{"data-svelte-h":!0}),i(d)!=="svelte-11uxp6"&&(d.innerHTML=z)},m(h,C){l(h,d,C)},p:pt,d(h){h&&t(d)}}}function vt(K){let d,z=`<code>BatchSampler</code>s with varying batch sizes are not enabled by default. To enable this behaviour, set <code>even_batches</code>
equal to <code>False</code>`;return{c(){d=n("p"),d.innerHTML=z},l(h){d=c(h,"P",{"data-svelte-h":!0}),i(d)!=="svelte-11uxp6"&&(d.innerHTML=z)},m(h,C){l(h,d,C)},p:pt,d(h){h&&t(d)}}}function $t(K){let d,z,h,C,q,fe,W,Je=`The internal classes Accelerate uses to prepare objects for distributed training
when calling <a href="/docs/accelerate/v0.26.0/en/package_reference/accelerator#accelerate.Accelerator.prepare">prepare()</a>.`,be,O,_e,_,F,Me,Q,Ke="Wraps a PyTorch <code>DataLoader</code> to generate batches for one of the processes only.",ke,Y,Qe=`Depending on the value of the <code>drop_last</code> attribute of the <code>dataloader</code> passed, it will either stop the iteration
at the first batch that would be too small / not present on all processes or loop with indices from the beginning.`,Pe,H,ve,S,E,Ie,Z,Ye="Creates a <code>torch.utils.data.DataLoader</code> that will efficiently skip the first <code>num_batches</code>.",$e,y,N,qe,ee,Ze=`Wraps a PyTorch <code>BatchSampler</code> to generate batches for one of the processes only. Instances of this class will
always yield a number of batches that is a round multiple of <code>num_processes</code> and that all have the same size.
Depending on the value of the <code>drop_last</code> attribute of the batch sampler passed, it will either stop the iteration
at the first batch that would be too small / not present on all processes or loop with indices from the beginning.`,We,M,ye,A,U,Oe,te,et=`Wraps a PyTorch <code>IterableDataset</code> to generate samples for one of the processes only. Instances of this class will
always yield a number of samples that is a round multiple of the actual batch size (depending of the value of
<code>split_batches</code>, this is either <code>batch_size</code> or <code>batch_size x num_processes</code>). Depending on the value of the
<code>drop_last</code> attribute of the batch sampler passed, it will either stop the iteration at the first batch that would
be too small or loop with indices from the beginning.`,we,v,B,Fe,ae,tt="Subclass of a PyTorch <code>DataLoader</code> that will deal with device placement and current distributed setup.",Ee,oe,at="<strong>Available attributes:</strong>",Ne,re,ot=`<li><p><strong>total_batch_size</strong> (<code>int</code>) — Total batch size of the dataloader across all processes.
Equal to the original batch size when <code>split_batches=True</code>; otherwise the original batch size * the total
number of processes</p></li> <li><p><strong>total_dataset_length</strong> (<code>int</code>) — Total length of the inner dataset across all processes.</p></li>`,xe,$,G,Ue,se,rt=`Subclass of a PyTorch <code>DataLoader</code> that will iterate and preprocess on process 0 only, then dispatch on each
process their part of the batch.`,Be,ne,st="<strong>Available attributes:</strong>",Ge,ce,nt=`<li><p><strong>total_batch_size</strong> (<code>int</code>) — Total batch size of the dataloader across all processes.
Equal to the original batch size when <code>split_batches=True</code>; otherwise the original batch size * the total
number of processes</p></li> <li><p><strong>total_dataset_length</strong> (<code>int</code>) — Total length of the inner dataset across all processes.</p></li>`,Te,R,ze,w,V,Re,le,ct="Internal wrapper around a torch optimizer.",Ve,de,lt=`Conditionally will perform <code>step</code> and <code>zero_grad</code> if gradients should be synchronized when performing gradient
accumulation.`,Le,j,De,x,X,je,ie,dt=`A wrapper around a learning rate scheduler that will only step when the optimizer(s) have a training step. Useful
to avoid making a scheduler step too fast when gradients went overflow and there was no training step (in mixed
precision training)`,Xe,he,it=`When performing gradient accumulation scheduler lengths should not be changed accordingly, Accelerate will always
step the scheduler to account for it.`,Se,ge,Ae;return q=new He({props:{title:"Wrapper classes for torch Dataloaders, Optimizers, and Schedulers",local:"wrapper-classes-for-torch-dataloaders-optimizers-and-schedulers",headingTag:"h1"}}),O=new He({props:{title:"Datasets and DataLoaders",local:"accelerate.data_loader.prepare_data_loader",headingTag:"h2"}}),F=new I({props:{name:"accelerate.data_loader.prepare_data_loader",anchor:"accelerate.data_loader.prepare_data_loader",parameters:[{name:"dataloader",val:": DataLoader"},{name:"device",val:": typing.Optional[torch.device] = None"},{name:"num_processes",val:": typing.Optional[int] = None"},{name:"process_index",val:": typing.Optional[int] = None"},{name:"split_batches",val:": bool = False"},{name:"put_on_device",val:": bool = False"},{name:"rng_types",val:": typing.Union[typing.List[typing.Union[str, accelerate.utils.dataclasses.RNGType]], NoneType] = None"},{name:"dispatch_batches",val:": typing.Optional[bool] = None"},{name:"even_batches",val:": bool = True"},{name:"slice_fn_for_dispatch",val:": typing.Optional[typing.Callable] = None"},{name:"use_seedable_sampler",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.data_loader.prepare_data_loader.dataloader",description:`<strong>dataloader</strong> (<code>torch.utils.data.dataloader.DataLoader</code>) &#x2014;
The data loader to split across several devices.`,name:"dataloader"},{anchor:"accelerate.data_loader.prepare_data_loader.device",description:`<strong>device</strong> (<code>torch.device</code>) &#x2014;
The target device for the returned <code>DataLoader</code>.`,name:"device"},{anchor:"accelerate.data_loader.prepare_data_loader.num_processes",description:`<strong>num_processes</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The number of processes running concurrently. Will default to the value given by
<a href="/docs/accelerate/v0.26.0/en/package_reference/state#accelerate.state.AcceleratorState">AcceleratorState</a>.`,name:"num_processes"},{anchor:"accelerate.data_loader.prepare_data_loader.process_index",description:`<strong>process_index</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The index of the current process. Will default to the value given by <a href="/docs/accelerate/v0.26.0/en/package_reference/state#accelerate.state.AcceleratorState">AcceleratorState</a>.`,name:"process_index"},{anchor:"accelerate.data_loader.prepare_data_loader.split_batches",description:`<strong>split_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the resulting <code>DataLoader</code> should split the batches of the original data loader across devices or
yield full batches (in which case it will yield batches starting at the <code>process_index</code>-th and advancing of
<code>num_processes</code> batches at each iteration).</p>
<p>Another way to see this is that the observed batch size will be the same as the initial <code>dataloader</code> if
this option is set to <code>True</code>, the batch size of the initial <code>dataloader</code> multiplied by <code>num_processes</code>
otherwise.</p>
<p>Setting this option to <code>True</code> requires that the batch size of the <code>dataloader</code> is a round multiple of
<code>batch_size</code>.`,name:"split_batches"},{anchor:"accelerate.data_loader.prepare_data_loader.put_on_device",description:`<strong>put_on_device</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to put the batches on <code>device</code> (only works if the batches are nested list, tuples or
dictionaries of tensors).`,name:"put_on_device"},{anchor:"accelerate.data_loader.prepare_data_loader.rng_types",description:`<strong>rng_types</strong> (list of <code>str</code> or <a href="/docs/accelerate/v0.26.0/en/package_reference/utilities#accelerate.utils.RNGType">RNGType</a>) &#x2014;
The list of random number generators to synchronize at the beginning of each iteration. Should be one or
several of:</p>
<ul>
<li><code>&quot;torch&quot;</code>: the base torch random number generator</li>
<li><code>&quot;cuda&quot;</code>: the CUDA random number generator (GPU only)</li>
<li><code>&quot;xla&quot;</code>: the XLA random number generator (TPU only)</li>
<li><code>&quot;generator&quot;</code>: the <code>torch.Generator</code> of the sampler (or batch sampler if there is no sampler in your
dataloader) or of the iterable dataset (if it exists) if the underlying dataset is of that type.</li>
</ul>`,name:"rng_types"},{anchor:"accelerate.data_loader.prepare_data_loader.dispatch_batches",description:`<strong>dispatch_batches</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, the datalaoder prepared is only iterated through on the main process and then the batches
are split and broadcast to each process. Will default to <code>True</code> when the underlying dataset is an
<code>IterableDataset</code>, <code>False</code> otherwise.`,name:"dispatch_batches"},{anchor:"accelerate.data_loader.prepare_data_loader.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, in cases where the total batch size across all processes does not exactly divide the
dataset, samples at the start of the dataset will be duplicated so the batch can be divided equally among
all workers.`,name:"even_batches"},{anchor:"accelerate.data_loader.prepare_data_loader.slice_fn_for_dispatch",description:"<strong>slice_fn_for_dispatch</strong> (<code>Callable</code>, <em>optional</em><code>) -- If passed, this function will be used to slice tensors across </code>num_processes<code>. Will default to [slice_tensors()](/docs/accelerate/v0.26.0/en/package_reference/utilities#accelerate.utils.slice_tensors). This argument is used only when </code>dispatch_batches<code>is set to</code>True` and will be\nignored otherwise.",name:"slice_fn_for_dispatch"},{anchor:"accelerate.data_loader.prepare_data_loader.use_seedable_sampler",description:`<strong>use_seedable_sampler</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use the <code>SeedableRandomSampler</code> instead of a <code>RandomSampler</code> for better
reproducability. Comes at a cost of potentially different performances due to different shuffling
algorithms but ensures results will be the <em>exact</em> same.`,name:"use_seedable_sampler"}],source:"https://github.com/huggingface/accelerate/blob/v0.26.0/src/accelerate/data_loader.py#L736",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A new data loader that will yield the portion of the batches</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.utils.data.dataloader.DataLoader</code></p>
`}}),H=new ht({props:{warning:!0,$$slots:{default:[_t]},$$scope:{ctx:K}}}),E=new I({props:{name:"accelerate.skip_first_batches",anchor:"accelerate.skip_first_batches",parameters:[{name:"dataloader",val:""},{name:"num_batches",val:" = 0"}],source:"https://github.com/huggingface/accelerate/blob/v0.26.0/src/accelerate/data_loader.py#L995"}}),N=new I({props:{name:"class accelerate.data_loader.BatchSamplerShard",anchor:"accelerate.data_loader.BatchSamplerShard",parameters:[{name:"*args",val:""},{name:"**kwds",val:""}],parametersDescription:[{anchor:"accelerate.data_loader.BatchSamplerShard.batch_sampler",description:`<strong>batch_sampler</strong> (<code>torch.utils.data.sampler.BatchSampler</code>) &#x2014;
The batch sampler to split in several shards.`,name:"batch_sampler"},{anchor:"accelerate.data_loader.BatchSamplerShard.num_processes",description:`<strong>num_processes</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of processes running concurrently.`,name:"num_processes"},{anchor:"accelerate.data_loader.BatchSamplerShard.process_index",description:`<strong>process_index</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The index of the current process.`,name:"process_index"},{anchor:"accelerate.data_loader.BatchSamplerShard.split_batches",description:`<strong>split_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the shards should be created by splitting a batch to give a piece of it on each process, or by
yielding different full batches on each process.</p>
<p>On two processes with a sampler of <code>[[0, 1, 2, 3], [4, 5, 6, 7]]</code>, this will result in:</p>
<ul>
<li>the sampler on process 0 to yield <code>[0, 1, 2, 3]</code> and the sampler on process 1 to yield <code>[4, 5, 6, 7]</code> if
this argument is set to <code>False</code>.</li>
<li>the sampler on process 0 to yield <code>[0, 1]</code> then <code>[4, 5]</code> and the sampler on process 1 to yield <code>[2, 3]</code>
then <code>[6, 7]</code> if this argument is set to <code>True</code>.</li>
</ul>`,name:"split_batches"},{anchor:"accelerate.data_loader.BatchSamplerShard.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to loop back at the beginning of the sampler when the number of samples is not a round
multiple of (original batch size / number of processes).`,name:"even_batches"}],source:"https://github.com/huggingface/accelerate/blob/v0.26.0/src/accelerate/data_loader.py#L99"}}),M=new ht({props:{warning:!0,$$slots:{default:[vt]},$$scope:{ctx:K}}}),U=new I({props:{name:"class accelerate.data_loader.IterableDatasetShard",anchor:"accelerate.data_loader.IterableDatasetShard",parameters:[{name:"*args",val:""},{name:"**kwds",val:""}],parametersDescription:[{anchor:"accelerate.data_loader.IterableDatasetShard.dataset",description:`<strong>dataset</strong> (<code>torch.utils.data.dataset.IterableDataset</code>) &#x2014;
The batch sampler to split in several shards.`,name:"dataset"},{anchor:"accelerate.data_loader.IterableDatasetShard.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The size of the batches per shard (if <code>split_batches=False</code>) or the size of the batches (if
<code>split_batches=True</code>).`,name:"batch_size"},{anchor:"accelerate.data_loader.IterableDatasetShard.drop_last",description:`<strong>drop_last</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to drop the last incomplete batch or complete the last batches by using the samples from the
beginning.`,name:"drop_last"},{anchor:"accelerate.data_loader.IterableDatasetShard.num_processes",description:`<strong>num_processes</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of processes running concurrently.`,name:"num_processes"},{anchor:"accelerate.data_loader.IterableDatasetShard.process_index",description:`<strong>process_index</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The index of the current process.`,name:"process_index"},{anchor:"accelerate.data_loader.IterableDatasetShard.split_batches",description:`<strong>split_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the shards should be created by splitting a batch to give a piece of it on each process, or by
yielding different full batches on each process.</p>
<p>On two processes with an iterable dataset yielding of <code>[0, 1, 2, 3, 4, 5, 6, 7]</code>, this will result in:</p>
<ul>
<li>the shard on process 0 to yield <code>[0, 1, 2, 3]</code> and the shard on process 1 to yield <code>[4, 5, 6, 7]</code> if this
argument is set to <code>False</code>.</li>
<li>the shard on process 0 to yield <code>[0, 1, 4, 5]</code> and the sampler on process 1 to yield <code>[2, 3, 6, 7]</code> if
this argument is set to <code>True</code>.</li>
</ul>`,name:"split_batches"}],source:"https://github.com/huggingface/accelerate/blob/v0.26.0/src/accelerate/data_loader.py#L255"}}),B=new I({props:{name:"class accelerate.data_loader.DataLoaderShard",anchor:"accelerate.data_loader.DataLoaderShard",parameters:[{name:"*args",val:""},{name:"**kwds",val:""}],parametersDescription:[{anchor:"accelerate.data_loader.DataLoaderShard.dataset",description:`<strong>dataset</strong> (<code>torch.utils.data.dataset.Dataset</code>) &#x2014;
The dataset to use to build this datalaoder.`,name:"dataset"},{anchor:"accelerate.data_loader.DataLoaderShard.device",description:`<strong>device</strong> (<code>torch.device</code>, <em>optional</em>) &#x2014;
If passed, the device to put all batches on.`,name:"device"},{anchor:"accelerate.data_loader.DataLoaderShard.rng_types",description:`<strong>rng_types</strong> (list of <code>str</code> or <a href="/docs/accelerate/v0.26.0/en/package_reference/utilities#accelerate.utils.RNGType">RNGType</a>) &#x2014;
The list of random number generators to synchronize at the beginning of each iteration. Should be one or
several of:</p>
<ul>
<li><code>&quot;torch&quot;</code>: the base torch random number generator</li>
<li><code>&quot;cuda&quot;</code>: the CUDA random number generator (GPU only)</li>
<li><code>&quot;xla&quot;</code>: the XLA random number generator (TPU only)</li>
<li><code>&quot;generator&quot;</code>: an optional <code>torch.Generator</code></li>
</ul>`,name:"rng_types"},{anchor:"accelerate.data_loader.DataLoaderShard.synchronized_generator",description:`<strong>synchronized_generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
A random number generator to keep synchronized across processes.`,name:"synchronized_generator"},{anchor:"accelerate.data_loader.DataLoaderShard.skip_batches",description:`<strong>skip_batches</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The number of batches to skip at the beginning.
kwargs &#x2014;
All other keyword arguments to pass to the regular <code>DataLoader</code> initialization.`,name:"skip_batches"}],source:"https://github.com/huggingface/accelerate/blob/v0.26.0/src/accelerate/data_loader.py#L390"}}),G=new I({props:{name:"class accelerate.data_loader.DataLoaderDispatcher",anchor:"accelerate.data_loader.DataLoaderDispatcher",parameters:[{name:"*args",val:""},{name:"**kwds",val:""}],parametersDescription:[{anchor:"accelerate.data_loader.DataLoaderDispatcher.split_batches",description:`<strong>split_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the resulting <code>DataLoader</code> should split the batches of the original data loader across devices or
yield full batches (in which case it will yield batches starting at the <code>process_index</code>-th and advancing of
<code>num_processes</code> batches at each iteration). Another way to see this is that the observed batch size will be
the same as the initial <code>dataloader</code> if this option is set to <code>True</code>, the batch size of the initial
<code>dataloader</code> multiplied by <code>num_processes</code> otherwise. Setting this option to <code>True</code> requires that the batch
size of the <code>dataloader</code> is a round multiple of <code>batch_size</code>.`,name:"split_batches"},{anchor:"accelerate.data_loader.DataLoaderDispatcher.skip_batches",description:`<strong>skip_batches</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The number of batches to skip at the beginning of an iteration.`,name:"skip_batches"}],source:"https://github.com/huggingface/accelerate/blob/v0.26.0/src/accelerate/data_loader.py#L547"}}),R=new He({props:{title:"Optimizers",local:"accelerate.optimizer.AcceleratedOptimizer",headingTag:"h2"}}),V=new I({props:{name:"class accelerate.optimizer.AcceleratedOptimizer",anchor:"accelerate.optimizer.AcceleratedOptimizer",parameters:[{name:"optimizer",val:""},{name:"device_placement",val:" = True"},{name:"scaler",val:" = None"}],parametersDescription:[{anchor:"accelerate.optimizer.AcceleratedOptimizer.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.optimizer.Optimizer</code>) &#x2014;
The optimizer to wrap.`,name:"optimizer"},{anchor:"accelerate.optimizer.AcceleratedOptimizer.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the optimizer should handle device placement. If so, it will place the state dictionary of
<code>optimizer</code> on the right device.`,name:"device_placement"},{anchor:"accelerate.optimizer.AcceleratedOptimizer.scaler",description:`<strong>scaler</strong> (<code>torch.cuda.amp.grad_scaler.GradScaler</code>, <em>optional</em>) &#x2014;
The scaler to use in the step function if training with mixed precision.`,name:"scaler"}],source:"https://github.com/huggingface/accelerate/blob/v0.26.0/src/accelerate/optimizer.py#L38"}}),j=new He({props:{title:"Schedulers",local:"accelerate.scheduler.AcceleratedScheduler",headingTag:"h2"}}),X=new I({props:{name:"class accelerate.scheduler.AcceleratedScheduler",anchor:"accelerate.scheduler.AcceleratedScheduler",parameters:[{name:"scheduler",val:""},{name:"optimizers",val:""},{name:"step_with_optimizer",val:": bool = True"},{name:"split_batches",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.scheduler.AcceleratedScheduler.scheduler",description:`<strong>scheduler</strong> (<code>torch.optim.lr_scheduler._LRScheduler</code>) &#x2014;
The scheduler to wrap.`,name:"scheduler"},{anchor:"accelerate.scheduler.AcceleratedScheduler.optimizers",description:`<strong>optimizers</strong> (one or a list of <code>torch.optim.Optimizer</code>) &#x2014;
The optimizers used.`,name:"optimizers"},{anchor:"accelerate.scheduler.AcceleratedScheduler.step_with_optimizer",description:`<strong>step_with_optimizer</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the scheduler should be stepped at each optimizer step.`,name:"step_with_optimizer"},{anchor:"accelerate.scheduler.AcceleratedScheduler.split_batches",description:`<strong>split_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the dataloaders split one batch across the different processes (so batch size is the same
regardless of the number of processes) or create batches on each process (so batch size is the original
batch size multiplied by the number of processes).`,name:"split_batches"}],source:"https://github.com/huggingface/accelerate/blob/v0.26.0/src/accelerate/scheduler.py#L25"}}),{c(){d=n("meta"),z=r(),h=n("p"),C=r(),p(q.$$.fragment),fe=r(),W=n("p"),W.innerHTML=Je,be=r(),p(O.$$.fragment),_e=r(),_=n("div"),p(F.$$.fragment),Me=r(),Q=n("p"),Q.innerHTML=Ke,ke=r(),Y=n("p"),Y.innerHTML=Qe,Pe=r(),p(H.$$.fragment),ve=r(),S=n("div"),p(E.$$.fragment),Ie=r(),Z=n("p"),Z.innerHTML=Ye,$e=r(),y=n("div"),p(N.$$.fragment),qe=r(),ee=n("p"),ee.innerHTML=Ze,We=r(),p(M.$$.fragment),ye=r(),A=n("div"),p(U.$$.fragment),Oe=r(),te=n("p"),te.innerHTML=et,we=r(),v=n("div"),p(B.$$.fragment),Fe=r(),ae=n("p"),ae.innerHTML=tt,Ee=r(),oe=n("p"),oe.innerHTML=at,Ne=r(),re=n("ul"),re.innerHTML=ot,xe=r(),$=n("div"),p(G.$$.fragment),Ue=r(),se=n("p"),se.innerHTML=rt,Be=r(),ne=n("p"),ne.innerHTML=st,Ge=r(),ce=n("ul"),ce.innerHTML=nt,Te=r(),p(R.$$.fragment),ze=r(),w=n("div"),p(V.$$.fragment),Re=r(),le=n("p"),le.textContent=ct,Ve=r(),de=n("p"),de.innerHTML=lt,Le=r(),p(j.$$.fragment),De=r(),x=n("div"),p(X.$$.fragment),je=r(),ie=n("p"),ie.textContent=dt,Xe=r(),he=n("p"),he.textContent=it,Se=r(),ge=n("p"),this.h()},l(e){const a=bt("svelte-u9bgzb",document.head);d=c(a,"META",{name:!0,content:!0}),a.forEach(t),z=s(e),h=c(e,"P",{}),L(h).forEach(t),C=s(e),m(q.$$.fragment,e),fe=s(e),W=c(e,"P",{"data-svelte-h":!0}),i(W)!=="svelte-1xa647o"&&(W.innerHTML=Je),be=s(e),m(O.$$.fragment,e),_e=s(e),_=c(e,"DIV",{class:!0});var T=L(_);m(F.$$.fragment,T),Me=s(T),Q=c(T,"P",{"data-svelte-h":!0}),i(Q)!=="svelte-18lxf6z"&&(Q.innerHTML=Ke),ke=s(T),Y=c(T,"P",{"data-svelte-h":!0}),i(Y)!=="svelte-15utu04"&&(Y.innerHTML=Qe),Pe=s(T),m(H.$$.fragment,T),T.forEach(t),ve=s(e),S=c(e,"DIV",{class:!0});var J=L(S);m(E.$$.fragment,J),Ie=s(J),Z=c(J,"P",{"data-svelte-h":!0}),i(Z)!=="svelte-a40iym"&&(Z.innerHTML=Ye),J.forEach(t),$e=s(e),y=c(e,"DIV",{class:!0});var pe=L(y);m(N.$$.fragment,pe),qe=s(pe),ee=c(pe,"P",{"data-svelte-h":!0}),i(ee)!=="svelte-1d4wgd"&&(ee.innerHTML=Ze),We=s(pe),m(M.$$.fragment,pe),pe.forEach(t),ye=s(e),A=c(e,"DIV",{class:!0});var Ce=L(A);m(U.$$.fragment,Ce),Oe=s(Ce),te=c(Ce,"P",{"data-svelte-h":!0}),i(te)!=="svelte-1t48as2"&&(te.innerHTML=et),Ce.forEach(t),we=s(e),v=c(e,"DIV",{class:!0});var k=L(v);m(B.$$.fragment,k),Fe=s(k),ae=c(k,"P",{"data-svelte-h":!0}),i(ae)!=="svelte-1pohj0z"&&(ae.innerHTML=tt),Ee=s(k),oe=c(k,"P",{"data-svelte-h":!0}),i(oe)!=="svelte-17v1xbv"&&(oe.innerHTML=at),Ne=s(k),re=c(k,"UL",{"data-svelte-h":!0}),i(re)!=="svelte-ixpwl0"&&(re.innerHTML=ot),k.forEach(t),xe=s(e),$=c(e,"DIV",{class:!0});var P=L($);m(G.$$.fragment,P),Ue=s(P),se=c(P,"P",{"data-svelte-h":!0}),i(se)!=="svelte-1885zty"&&(se.innerHTML=rt),Be=s(P),ne=c(P,"P",{"data-svelte-h":!0}),i(ne)!=="svelte-17v1xbv"&&(ne.innerHTML=st),Ge=s(P),ce=c(P,"UL",{"data-svelte-h":!0}),i(ce)!=="svelte-ixpwl0"&&(ce.innerHTML=nt),P.forEach(t),Te=s(e),m(R.$$.fragment,e),ze=s(e),w=c(e,"DIV",{class:!0});var me=L(w);m(V.$$.fragment,me),Re=s(me),le=c(me,"P",{"data-svelte-h":!0}),i(le)!=="svelte-1kknwnf"&&(le.textContent=ct),Ve=s(me),de=c(me,"P",{"data-svelte-h":!0}),i(de)!=="svelte-vsq67w"&&(de.innerHTML=lt),me.forEach(t),Le=s(e),m(j.$$.fragment,e),De=s(e),x=c(e,"DIV",{class:!0});var ue=L(x);m(X.$$.fragment,ue),je=s(ue),ie=c(ue,"P",{"data-svelte-h":!0}),i(ie)!=="svelte-ebdman"&&(ie.textContent=dt),Xe=s(ue),he=c(ue,"P",{"data-svelte-h":!0}),i(he)!=="svelte-1g111ye"&&(he.textContent=it),ue.forEach(t),Se=s(e),ge=c(e,"P",{}),L(ge).forEach(t),this.h()},h(){D(d,"name","hf:doc:metadata"),D(d,"content",yt),D(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){o(document.head,d),l(e,z,a),l(e,h,a),l(e,C,a),u(q,e,a),l(e,fe,a),l(e,W,a),l(e,be,a),u(O,e,a),l(e,_e,a),l(e,_,a),u(F,_,null),o(_,Me),o(_,Q),o(_,ke),o(_,Y),o(_,Pe),u(H,_,null),l(e,ve,a),l(e,S,a),u(E,S,null),o(S,Ie),o(S,Z),l(e,$e,a),l(e,y,a),u(N,y,null),o(y,qe),o(y,ee),o(y,We),u(M,y,null),l(e,ye,a),l(e,A,a),u(U,A,null),o(A,Oe),o(A,te),l(e,we,a),l(e,v,a),u(B,v,null),o(v,Fe),o(v,ae),o(v,Ee),o(v,oe),o(v,Ne),o(v,re),l(e,xe,a),l(e,$,a),u(G,$,null),o($,Ue),o($,se),o($,Be),o($,ne),o($,Ge),o($,ce),l(e,Te,a),u(R,e,a),l(e,ze,a),l(e,w,a),u(V,w,null),o(w,Re),o(w,le),o(w,Ve),o(w,de),l(e,Le,a),u(j,e,a),l(e,De,a),l(e,x,a),u(X,x,null),o(x,je),o(x,ie),o(x,Xe),o(x,he),l(e,Se,a),l(e,ge,a),Ae=!0},p(e,[a]){const T={};a&2&&(T.$$scope={dirty:a,ctx:e}),H.$set(T);const J={};a&2&&(J.$$scope={dirty:a,ctx:e}),M.$set(J)},i(e){Ae||(g(q.$$.fragment,e),g(O.$$.fragment,e),g(F.$$.fragment,e),g(H.$$.fragment,e),g(E.$$.fragment,e),g(N.$$.fragment,e),g(M.$$.fragment,e),g(U.$$.fragment,e),g(B.$$.fragment,e),g(G.$$.fragment,e),g(R.$$.fragment,e),g(V.$$.fragment,e),g(j.$$.fragment,e),g(X.$$.fragment,e),Ae=!0)},o(e){f(q.$$.fragment,e),f(O.$$.fragment,e),f(F.$$.fragment,e),f(H.$$.fragment,e),f(E.$$.fragment,e),f(N.$$.fragment,e),f(M.$$.fragment,e),f(U.$$.fragment,e),f(B.$$.fragment,e),f(G.$$.fragment,e),f(R.$$.fragment,e),f(V.$$.fragment,e),f(j.$$.fragment,e),f(X.$$.fragment,e),Ae=!1},d(e){e&&(t(z),t(h),t(C),t(fe),t(W),t(be),t(_e),t(_),t(ve),t(S),t($e),t(y),t(ye),t(A),t(we),t(v),t(xe),t($),t(Te),t(ze),t(w),t(Le),t(De),t(x),t(Se),t(ge)),t(d),b(q,e),b(O,e),b(F),b(H),b(E),b(N),b(M),b(U),b(B),b(G),b(R,e),b(V),b(j,e),b(X)}}}const yt='{"title":"Wrapper classes for torch Dataloaders, Optimizers, and Schedulers","local":"wrapper-classes-for-torch-dataloaders-optimizers-and-schedulers","sections":[{"title":"Datasets and DataLoaders","local":"accelerate.data_loader.prepare_data_loader","sections":[],"depth":2},{"title":"Optimizers","local":"accelerate.optimizer.AcceleratedOptimizer","sections":[],"depth":2},{"title":"Schedulers","local":"accelerate.scheduler.AcceleratedScheduler","sections":[],"depth":2}],"depth":1}';function wt(K){return ut(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class St extends gt{constructor(d){super(),ft(this,d,wt,$t,mt,{})}}export{St as component};
